package sort;
import test.AbstractTest;

public class SortTest extends AbstractTest {

	public static void main(String[] args) {
		System.out.println("start SortTest");
		SortTest pt = new SortTest("./sort.xml", "./sort.txt");
		pt.doAllTests();
		pt.printReport();
		System.out.println("\nend SortTest");
	}	
	
	private AbstractSort P;

	private String res, pgm, type;

	private int n;

	protected SortTest(String input, String output) {
		super(input, output);
	}

	protected void pre() {
		type = H.get("TYPE");
		
		n = Integer.parseInt(H.get("N"));
		
		pgm = H.get("PGM");
		if (pgm.equals("QuickSort")) P = new QuickSort();
		else if (pgm.equals("HeapSort")) P = new HeapSort();
		else if (pgm.equals("MergeSort")) P = new MergeSort();
		else if (pgm.equals("SelectionSort")) P = new SelectionSort();
		else if (pgm.equals("InsertionSort")) P = new InsertionSort();
		else if (pgm.equals("BubbleSort")) P = new BubbleSort();
	
		else throw new IllegalArgumentException(" Unknown PGM");
		
		P.pre(n, type);
	}

	protected void go() {
		System.out.println(" testing "+pgm+" size "+n+" type "+type);	
		P.go();
	}

	protected void post() {
		if (P.verify()) res = "OK";
		else res = "NO";
		System.out.println("    res ="+res);
		reportT.put(n+"-"+type, pgm, time);
		reportM.put(n+"-"+type, pgm, mem);
	}

	protected String getRes() {
		return res;
	}

}
