package test;

import java.io.*;
import java.util.*;

public abstract class AbstractTest {
	private XMLBatch data;
	private PrintWriter out = null;
	protected String res, time, mem;
	protected Report reportT, reportM;
	protected Map<String, String> H;

	protected AbstractTest(String input, String output) {
		try {
			this.out = new PrintWriter(new BufferedWriter(new FileWriter(output)));
		}
		catch (IOException e) { 
			e.printStackTrace();
		}
		this.data = new XMLBatch(input);
		this.reportT = new Report();
		this.reportM = new Report();
	}

	public void doAllTests() {
		for (Map<String, String> h : data) {
			this.H = h;
			System.out.println(" input data: " + H);
			pre();
			initTime();
			go();
			time =askTime() + "s";
			mem = askMemory() + "M";
			post();
			res = getRes();
			if (!res.equals("OK")) {
				out.println();
				out.println(" input data: " + H);
				out.println(" result:     " + res);
				out.println(" time:       " + time + " memory:       " + mem);
				out.flush();
			}
		}
	}

	protected abstract void pre();

	protected abstract void go();

	protected abstract void post();

	protected abstract String getRes();

	public void printReport() {
		String[][] restab = reportT.getReport(); 
		out.println("TEMPO");
		for (int i = 0; i < restab.length; i++) {
			for (int j = 0; j < restab[0].length; j++)
				out.print(restab[i][j]);
			out.println();
		}
		out.println();
		
		restab = reportM.getReport();
		out.println("MEMORIA");
		for (int i = 0; i < restab.length; i++) {
			for (int j = 0; j < restab[0].length; j++)
				out.print(restab[i][j]);
			out.println();
		}
		out.println();
		out.close();
	}

	//  calcolo del tempo e della memoria
	
	private static Runtime R = Runtime.getRuntime();

	private static double time0;

	public static void initTime() {
		time0 = System.currentTimeMillis();
	}

	public static double askTime() {
		return(System.currentTimeMillis() - time0) / 1000.;
	}

	public static double askMemory() {
		R.gc();
		return ((int)(((R.totalMemory() - R.freeMemory()) / (1024. * 1024.))*100)/100.);
	}
}