package test;

import java.io.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.util.*;

public class XMLBatch extends DefaultHandler implements Iterable<Map<String, String>> {

	private Vector<Map<String, String>> V = new Vector<Map<String, String>>();

	private Map<String, String> H = new HashMap<String, String>();

	public XMLBatch(String filename) {
		File file = new File(filename);
		try {
			SAXParserFactory.newInstance().newSAXParser().parse(file, this);
		}
		catch (Throwable t) {
			t.printStackTrace();
		}
	}

	/*
	 * il metodo seguente ridefinisce startElement dell'interfaccia
	 * DefaultHandler e viene invocato dal parser XML ogni volta che si legge un
	 * elemento (ITEM nel nostro caso) name è il nome dell'elemento atts la
	 * lista degli attributi
	 */

	public void startElement(String namespaceURI, String dummy, String name, Attributes atts) throws SAXException {
		if (name.equals("TEST")) {
			for (int i = 0; i < atts.getLength(); i++)
				H.put(atts.getQName(i), atts.getValue(i));
			V.addElement(new HashMap<String, String>(H));
		}
	}

	public Iterator<Map<String, String>> iterator() {
		return V.iterator();
	}
}
